# This file was auto-generated by Fern from our API Definition.

from .base_inbox_search_request import BaseInboxSearchRequest
import typing
from ...commons.types.inbox_item_status import InboxItemStatus
import pydantic
from ...commons.types.inbox_item_type import InboxItemType
import typing_extensions
import datetime as dt
from ...core.serialization import FieldMetadata
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class InboxSearchRequest(BaseInboxSearchRequest):
    statuses: typing.Optional[typing.List[InboxItemStatus]] = pydantic.Field(default=None)
    """
    List of inbox item statuses to filter by.
    """

    type: typing.Optional[typing.List[InboxItemType]] = pydantic.Field(default=None)
    """
    List of inbox item types to filter by.
    """

    created_after: typing_extensions.Annotated[typing.Optional[dt.datetime], FieldMetadata(alias="createdAfter")] = (
        pydantic.Field(default=None)
    )
    """
    Filter for items created after this timestamp.
    """

    created_before: typing_extensions.Annotated[typing.Optional[dt.datetime], FieldMetadata(alias="createdBefore")] = (
        pydantic.Field(default=None)
    )
    """
    Filter for items created before this timestamp.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
